#ifndef __backend_h__
#define __backend_h__

#include "ast.h"
#include "printer.h"

class BEPerlVisitor : public ASTVisitor
{
  Printer *printer;
  
public:
  BEPerlVisitor(Printer *printer);
  virtual ~BEPerlVisitor();
  virtual void visit(ASTConstNumber *peer);
  virtual void visit(ASTLambdaExpression *peer);
  virtual void visit(ASTLetBindingExpression *peer);
  virtual void visit(ASTBaseType *peer);
  virtual void visit(ASTInfixOpExpression *peer);
  virtual void visit(ASTVariable *peer);
  virtual void visit(ASTTypeVariable *peer);
  virtual void visit(ASTUnionType *peer);
  virtual void visit(ASTTensorType *peer);
  virtual void visit(ASTAmpersandType *peer);
  virtual void visit(ASTFuzzyType *peer);
  virtual void visit(ASTUnitType *peer);
  virtual void visit(ASTFunctionType *peer);
  virtual void visit(ASTMuType *peer);
  virtual void visit(ASTCaseExpression *peer);
  virtual void visit(ASTUnfoldExpression *peer);
  virtual void visit(ASTBuiltinExpression *peer);
  virtual void visit(ASTFoldExpression *peer);
  virtual void visit(ASTInjectExpression *peer);
  virtual void visit(ASTProjectExpression *peer);
  virtual void visit(ASTTensorTuple *peer);
  virtual void visit(ASTTensorDestructorExpression *peer);
  virtual void visit(ASTAmpersandTuple *peer);
  virtual void visit(ASTApplyExpression *peer);
  virtual void visit(ASTUnitValue *peer);
  virtual void visit(ASTTypeDefExpression *peer);
  virtual void visit(ASTNamedType *peer);
  virtual void visit(ASTSetType *peer);
};

class BESchemeVisitor : public ASTVisitor
{
  Printer *printer;
  
public:
  BESchemeVisitor(Printer *printer);
  virtual ~BESchemeVisitor();
  virtual void visit(ASTConstNumber *peer);
  virtual void visit(ASTLambdaExpression *peer);
  virtual void visit(ASTLetBindingExpression *peer);
  virtual void visit(ASTBaseType *peer);
  virtual void visit(ASTInfixOpExpression *peer);
  virtual void visit(ASTVariable *peer);
  virtual void visit(ASTTypeVariable *peer);
  virtual void visit(ASTUnionType *peer);
  virtual void visit(ASTTensorType *peer);
  virtual void visit(ASTAmpersandType *peer);
  virtual void visit(ASTFuzzyType *peer);
  virtual void visit(ASTUnitType *peer);
  virtual void visit(ASTFunctionType *peer);
  virtual void visit(ASTMuType *peer);
  virtual void visit(ASTCaseExpression *peer);
  virtual void visit(ASTUnfoldExpression *peer);
  virtual void visit(ASTBuiltinExpression *peer);
  virtual void visit(ASTFoldExpression *peer);
  virtual void visit(ASTInjectExpression *peer);
  virtual void visit(ASTProjectExpression *peer);
  virtual void visit(ASTTensorTuple *peer);
  virtual void visit(ASTTensorDestructorExpression *peer);
  virtual void visit(ASTAmpersandTuple *peer);
  virtual void visit(ASTApplyExpression *peer);
  virtual void visit(ASTUnitValue *peer);
  virtual void visit(ASTTypeDefExpression *peer);
  virtual void visit(ASTNamedType *peer);
  virtual void visit(ASTSetType *peer);
  virtual void visit(ASTIfThenElseExpression *peer);
  virtual void visit(ASTSampleExpression *peer);
  virtual void visit(ASTConstString *peer);
};

class BECamlVisitor : public ASTVisitor
{
  Printer *printer;
  
public:
  BECamlVisitor(Printer *printer);
  virtual ~BECamlVisitor();
  virtual void visit(ASTConstNumber *peer);
  virtual void visit(ASTLambdaExpression *peer);
  virtual void visit(ASTLetBindingExpression *peer);
  virtual void visit(ASTBaseType *peer);
  virtual void visit(ASTInfixOpExpression *peer);
  virtual void visit(ASTVariable *peer);
  virtual void visit(ASTTypeVariable *peer);
  virtual void visit(ASTUnionType *peer);
  virtual void visit(ASTTensorType *peer);
  virtual void visit(ASTAmpersandType *peer);
  virtual void visit(ASTFuzzyType *peer);
  virtual void visit(ASTUnitType *peer);
  virtual void visit(ASTFunctionType *peer);
  virtual void visit(ASTMuType *peer);
  virtual void visit(ASTCaseExpression *peer);
  virtual void visit(ASTUnfoldExpression *peer);
  virtual void visit(ASTBuiltinExpression *peer);
  virtual void visit(ASTFoldExpression *peer);
  virtual void visit(ASTInjectExpression *peer);
  virtual void visit(ASTProjectExpression *peer);
  virtual void visit(ASTTensorTuple *peer);
  virtual void visit(ASTTensorDestructorExpression *peer);
  virtual void visit(ASTAmpersandTuple *peer);
  virtual void visit(ASTApplyExpression *peer);
  virtual void visit(ASTUnitValue *peer);
  virtual void visit(ASTTypeDefExpression *peer);
  virtual void visit(ASTNamedType *peer);
  virtual void visit(ASTSetType *peer);
  virtual void visit(ASTIfThenElseExpression *peer);
  virtual void visit(ASTSampleExpression *peer);
  virtual void visit(ASTConstString *peer);
};

#endif /* defined(__backend_h__) */
