#ifndef __dump_h__
#define __dump_h__

#include "ast.h"
#include "printer.h"

/* ASTDumpVisitor: Basically a pretty-printer that displays an AST. Useful to check whether
   the parser worked properly. */

class ASTDumpVisitor : public ASTVisitor
{
  Printer *printer;
  bool singleMode;
  
public:
  ASTDumpVisitor(Printer *printer, bool singleMode = false);
  virtual ~ASTDumpVisitor();
  virtual void visit(ASTBaseType *peer);
  virtual void visit(ASTTypeVariable *peer);
  virtual void visit(ASTUnionType *peer);
  virtual void visit(ASTTensorType *peer);
  virtual void visit(ASTAmpersandType *peer);
  virtual void visit(ASTFuzzyType *peer);
  virtual void visit(ASTUnitType *peer);
  virtual void visit(ASTFunctionType *peer);
  virtual void visit(ASTMuType *peer);
  virtual void visit(ASTVariable *peer);
  virtual void visit(ASTCaseExpression *peer);
  virtual void visit(ASTInfixOpExpression *peer);
  virtual void visit(ASTUnfoldExpression *peer);
  virtual void visit(ASTBuiltinExpression *peer);
  virtual void visit(ASTFoldExpression *peer);
  virtual void visit(ASTInjectExpression *peer);
  virtual void visit(ASTProjectExpression *peer);
  virtual void visit(ASTTensorTuple *peer);
  virtual void visit(ASTTensorDestructorExpression *peer);
  virtual void visit(ASTAmpersandTuple *peer);
  virtual void visit(ASTLetBindingExpression *peer);
  virtual void visit(ASTLambdaExpression *peer);
  virtual void visit(ASTApplyExpression *peer);
  virtual void visit(ASTUnitValue *peer);
  virtual void visit(ASTConstNumber *peer);
  virtual void visit(ASTTypeDefExpression *peer);
  virtual void visit(ASTNamedType *peer);
  virtual void visit(ASTSetType *peer);
  virtual void visit(ASTSetExpression *peer);
  virtual void visit(ASTSampleExpression *peer);
  virtual void visit(ASTSingleValueDistribution *peer);
  virtual void visit(ASTLaplaceDistribution *peer);
  virtual void visit(ASTConstBool *peer);
  virtual void visit(ASTIfThenElseExpression *peer);
  virtual void visit(ASTPrintExpression *peer);
  virtual void visit(ASTConstString *peer);
};

char *prettyDouble(double d, char *buf);

#endif /* defined(__dump_h__) */
