#include "ast.h"

ASTSetExpression::ASTSetExpression(ASTType *memberType, bool isMulti, SourceContext *context) : ASTExpression(context) 
{
  this->memberType = memberType; 
  this->elements = NULL;
  this->isMulti = isMulti;
}

bool ASTSetExpression::contains(ASTExpression *val)
{
  struct elementStruct *iter = elements;
  
  while (iter) {
    if (iter->value->equals(val))
      return true;
      
    iter = iter->next;
  }
  
  return false;
}

void ASTSetExpression::add(ASTExpression *element)
{
  if (this->contains(element) && !isMulti)
    return;

  struct elementStruct *elem = (struct elementStruct *) malloc(sizeof(struct elementStruct));
  elem->value = element->clone();
  elem->next = elements;
  elements = elem;
}

ASTExpression *ASTSetExpression::clone()
{
  ASTSetExpression *val = new ASTSetExpression(memberType->clone(), isMulti, context ? context->clone() : NULL);
  struct elementStruct *iter = elements;
  
  while (iter) {
    val->add(iter->value->clone());
    iter = iter->next;
  }
  
  return val;
}

int ASTSetExpression::count()
{
  int result = 0;
  struct elementStruct *iter = elements;
  while (iter) {
    result ++;
    iter = iter->next;
  }
  
  return result;
}
