#include <assert.h>

#include "ast.h"

void TCVariableMapping::addMapping(const char *name, const char *mappedName)
{
  assert(!mappingExists(name));
  struct mapEntry *entry = (struct mapEntry*) malloc(sizeof(struct mapEntry));
  entry->name = (char*) malloc(strlen(name)+1);
  strcpy(entry->name, name);
  entry->mappedName = (char*) malloc(strlen(mappedName)+1);
  strcpy(entry->mappedName, mappedName);
  entry->next = maps;
  entry->prev = NULL;
  maps = entry;
}

void TCVariableMapping::removeMapping(const char *name)
{
  struct mapEntry *iter = maps;
  while (iter) {
    if (!strcmp(iter->name, name)) {
      if (maps == iter)
        maps = iter->next;
      if (iter->next)
        iter->next->prev = iter->prev;
      if (iter->prev)
        iter->prev->next = iter->next;
      free(iter->name);
      free(iter->mappedName);
      free(iter);
      return;
    }
    
    iter = iter->next;
  }
  
  assert(false);
}

const char *TCVariableMapping::lookupMapping(const char *name)
{
  struct mapEntry *iter = maps;
  while (iter) {
    if (!strcmp(iter->name, name))
      return iter->mappedName;
    
    iter = iter->next;
  }
  
  return NULL;
}


